#<profile4xi profile = "12" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "constant_heap4xi.py">
#<abstract4xi abstract = "Provides the class ConstantHeap4Xi."/>
#<refer4xi reference = "connection.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------





# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'constant_heap4xi', 'init_alignment4xi', 'set_alignment4xi', 'get_alignment4xi', 'ConstantHeap4Xi']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import errno
import io
import itertools
import os
import pickle
import select
import socket
import struct
import sys
import time
import tempfile
try:
    import _winapi
    from _winapi import WAIT_OBJECT_0, WAIT_TIMEOUT, INFINITE
except ImportError:
    if sys.platform == 'win32':
        raise
    _winapi = None        
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
from multiprocessing import connection
#"
#/>
     
# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ALIGNMENT4XI
#"
#/>
# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ALIGNMENT4XI = 8 
#"
#"/>
                        

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from print4xi import print4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from time4xi import time4xi
#"
#/>

# =================================================================================================
# I Object ALIGNMENT4XI
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "constant-heap4xi" usage = "
# defines constants for heap
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def constant_heap4xi(self, constant_heap4xi_param):
    '''
    constant_heap4xi defines constants for heap

    '''
    global ALIGNMENT4XI
    
    class2print = 'constant_heap4xi'
    method2print = 'constant_heap4xi'
    
    message2print = "{started" + "; constant-heap4xi-started: " + str(constant_heap4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        

    message2print = "{passed" + "; constant-heap4xi-param-passed-to-constant-heap4xi: " + str(constant_heap4xi_param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                
  
    if constant_heap4xi_param == 1:
        message2print = "{returning" + "; alignment4xi-returning-by-constant-heap4xi: " + str(ALIGNMENT4XI) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
    
        return ALIGNMENT4XI
    
    message2print = "{returning" + "; false-returning-by-constant-heap4xi: " + str(False) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
    
    return False        
#</function4xi> 

 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-alignment4xi" usage = "
# initializes ALIGNMENTXI
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_alignment4xi(init_alignment4xi_param):          
    '''
    init_alignment4xi initializes ALIGNMENTXI
    '''
    global ALIGNMENT4XI


    class2print = 'init_alignment4xi'
    method2print = 'init_alignment4xi'
    
    message2print = "{started" + "; init-alignment4xi-started: " + str(init_alignment4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     

    message2print = "{passed" + "; init-alignment4xi-param-passed-to-init-alignment4xi: " + str(init_alignment4xi_param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
          

    ALIGNMENT4XI = init_alignment4xi_param    
        
   
#</function4xi> 

       

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-alignment4xi" usage = "
# sets ALIGNMENT4XI
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def set_alignment4xi(set_alignment4xi_param):          
    '''
    set_alignment4xi sets ALIGNMENT4XI
    '''
    global ALIGNMENT4XI
 

    class2print = 'set_alignment4xi'
    method2print = 'set_alignment4xi'
    
    message2print = "{started" + "; set-alignment4xi-started: " + str(set_alignment4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
    

    message2print = "{passed" + "; set-alignment4xi-param-passed-to-set-alignment4xi: " + str(set_alignment4xi_param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
  
    ALIGNMENT4XI = set_alignment4xi_param  
    
   
#</function4xi> 

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-alignment4xi" usage = "
# gets ALIGNMENT4XI
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_alignment4xi():          
    '''
    get_alignment4xi gets ALIGNMENT4XI
    '''
    global ALIGNMENT4XI

    
    class2print = 'get_alignment4xi'
    method2print = 'get_alignment4xi'
    
    message2print = "{started" + "; get-alignment4xi-started: " + str(get_alignment4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    
    
    message2print = "{returning" + "; alignment4xi-returning-by-get-alignment4xi: " + str(ALIGNMENT4XI) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
   
    return ALIGNMENT4XI
#</function4xi> 

 



    
# =================================================================================================
# ConstantHeap4Xi class
#<class4xi class = "ConstantHeap4Xi" base = "object" child = "None" synopsis = "offers services for heap constants" usage = "memory management"
#>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
class ConstantHeap4Xi(object): #<-- inherits from object class
    '''
    ConstantHeap4Xi offers services for heap constants
    '''            
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('init_alignment', 'set_alignment', 'get_alignment',
                 'sense', 'reason', 'ace')          
    #"
    #/>
                                     
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-ConstantHeap4Xi" usage = "initializes heap constants">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------   
    def __init__(self, alignment_param=8):
        '''
        _init__ initializes heap constants
        '''       
        class2print = 'ConstantHeap4Xi'
        method2print = '__init__'
        
        message2print = "{started" + "; init-of-ConstantHeap4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{borning" + "; constantheap4xi-of-ConstantHeap4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       

        message2print = "{inheriting" + "; object-inheriting-by-constantheap4xi-of-ConstantHeap4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        message2print = "{passed" + "; alignment-param-passed-to-init-of-ConstantHeap4Xi: " + str(alignment_param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        init_alignment4xi(alignment_param)    

        message2print = "{activated" + "; constantheap4xi-of-ConstantHeap4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          

        message2print = "{inherited" + "; object-inherited-by-constantheap4xi-of-ConstantHeap4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
          

    #</methodize4xi>
       
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-alignment-of-ConstantHeap4Xi" usage = "initializes ALIGNMENT4XI">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def init_alignment(self, init_alignment_param):          
        '''
        init_alignment initializes ALIGNMENT4XI
        '''
        class2print = 'ConstantHeap4Xi'
        method2print = 'init_alignment'
        
        message2print = "{started" + "; init-alignment-of-ConstantHeap4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
    
        message2print = "{passed" + "; init-alignment-param-passed-to-init-alignment-of-ConstantHeap4Xi: " + str(init_alignment_param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
                 
        init_alignment4xi(init_alignment_param)      
    
   
    #</methodize4xi>
           
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-alignment-of-ConstantHeap4Xi" usage = "sets ALIGNMENT4XI">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def set_alignment(self, set_alignment_param):          
        '''
        set_alignment sets ALIGNMENT4XI
        '''
        class2print = 'ConstantHeap4Xi'
        method2print = 'set_alignment'
        
        message2print = "{started" + "; set-alignment-of-ConstantHeap4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
    
        message2print = "{passed" + "; set-alignment-param-passed-to-set-alignment-of-ConstantHeap4Xi: " + str(set_alignment_param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
      
         
        set_alignment4xi(set_alignment_param)              
    

    #</methodize4xi>
            
        
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-alignment-of-ConstantHeap4Xi" usage = "gets ALIGNMENT4XI">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def get_alignment(self):          
        '''
        get_alignment gets ALIGNMENT4XI
        '''
        class2print = 'ConstantHeap4Xi'
        method2print = 'get_alignment'
        
        message2print = "{started" + "; get-alignment-of-ConstantHeap4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
      
        return get_alignment4xi()
    #</methodize4xi>
    
                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-ConstantHeap4Xi" usage = "senses class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses ConstantHeap4Xi class objects
        '''
          
        
        class2print = 'ConstantHeap4Xi'
        method2print = 'sense'
        
        message2print = "{started" + "; sense-of-ConstantHeap4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; constantheap4xi-sensing-by-sense-of-ConstantHeap4Xi: " + str(ConstantHeap4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                     
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-ConstantHeap4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                      
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------         
        try:
        
            kb2xi['inheritance-of-constantheap2xi'] = object
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-ConstantHeap4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 

            
        message2print = "{sensed" + "; constantheap4xi-sensed-by-sense-of-ConstantHeap4Xi: " + str(ConstantHeap4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
          
      
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-ConstantHeap4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                 
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-ConstantHeap4Xi" usage = "reasons class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        reasons ConstantHeap4Xi class objects
        '''
                 
        
        class2print = 'ConstantHeap4Xi'
        method2print = 'reason'

        message2print = "{started" + "; reason-of-ConstantHeap4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; constantheap4xi-reasoning-by-reason-of-ConstantHeap4Xi: " + str(ConstantHeap4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                       
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-ConstantHeap4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                      
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        message2print = "{reasoned" + "; constantheap4xi-reasoned-by-reason-of-ConstantHeap4Xi: " + str(ConstantHeap4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-ConstantHeap4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-ConstantHeap4Xi" usage = "aces class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        aces ConstantHeap4Xi class objects 
        '''
               
        
        
        class2print = 'ConstantHeap4Xi'
        method2print = 'ace'
        
        message2print = "{started" + "; ace-of-ConstantHeap4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; constantheap4xi-acing-by-ace-of-ConstantHeap4Xi: " + str(ConstantHeap4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
         
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-ConstantHeap4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                             

        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        message2print = "{aced" + "; constantheap4xi-aced-by-ace-of-ConstantHeap4Xi: " + str(ConstantHeap4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
          
       
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-ConstantHeap4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                               
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
    #</methodize4xi>
    
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_constant_heap4xi.txt
#   sense-test-constant-heap4xi.xml
#   reason-test-constant-heap4xi.xml
#   ace-test-constant-heap4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

    
    
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of constant_heap4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
